package org.churchsw.scripture.studyware;

import java.awt.FlowLayout;
import java.awt.GridLayout;
import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.net.MalformedURLException;
import java.util.Properties;

import javax.swing.JComboBox;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;

public class StrongDB {

	public static boolean reloadAfterPluginExecute=true;
	public static String version = "1.0";
	public static String builddate = "20-Sep-2009";
	public static Properties meanings = new Properties();
	public static Properties words = new Properties();
	public static Properties verses = new Properties();
	public static Properties plugins = new Properties();
	
	public static void init() throws FileNotFoundException, IOException {
		meanings.load(new FileInputStream("strongs_dic.prop"));
		words.load(new FileInputStream("strongs_seq.prop"));
		verses.load(new FileInputStream("strongs_ref.prop"));
		plugins.load(new FileInputStream("plugins.prop"));
	}

	public static String[] Bible_Books = new String[] { "Genesis", "Exodus",
			"Leviticus", "Numbers", "Deuteronomy", "Joshua", "Judges", "Ruth",
			"1 Samuel", "2 Samuel", "1 Kings", "2 Kings", "1 Chronicles",
			"2 Chronicles", "Ezra", "Nehemiah", "Esther", "Job", "Psalm",
			"Proverbs", "Ecclesiastes", "Song of Solomon", "Isaiah",
			"Jeremiah", "Lamentations", "Ezekiel", "Daniel", "Hosea", "Joel",
			"Amos", "Obadiah", "Jonah", "Micah", "Nahum", "Habakkuk",
			"Zephaniah", "Haggai", "Zechariah", "Malachi", "Matthew", "Mark",
			"Luke", "John", "Acts", "Romans", "1 Corinthians", "2 Corinthians",
			"Galatians", "Ephesians", "Philippians", "Colossians",
			"1 Thessalonians", "2 Thessalonians", "1 Timothy", "2 Timothy",
			"Titus", "Philemon", "Hebrews", "James", "1 Peter", "2 Peter",
			"1 John", "2 John", "3 John", "Jude", "Revelation" };

	public static int[] Bible_ChapterCount = new int[] { 50, 40, 27, 36, 34,
			24, 21, 4, 31, 24, 22, 25, 29, 36, 10, 13, 10, 42, 150, 31, 12, 8,
			66, 52, 5, 48, 12, 14, 3, 9, 1, 4, 7, 3, 3, 3, 2, 14, 4, 28, 16,
			24, 21, 28, 16, 16, 13, 6, 6, 4, 4, 5, 3, 6, 4, 3, 1, 13, 5, 5, 3,
			5, 1, 1, 1, 22 };

	public static String[] getBibleBooks() {

		return Bible_Books;
	}

	public static int getChapterCount(int i) {

		return Bible_ChapterCount[i - 1];
	}

	public static void getChapterPanel(JPanel chapterPanel, int book_no,
			int chapter_no) throws Exception {
		chapterPanel.removeAll();
		int chap_verse_count = 0;
		Properties chapverse = new Properties();
		for (int i = 1; i < 500; i++) {
			if (verses.getProperty(book_no + "." + chapter_no + "." + i) == null)
			{
				chap_verse_count = (i-1);
				break;
			}
			else
				chapverse.setProperty(book_no + "." + chapter_no + "." + i,
						verses
								.getProperty(book_no + "." + chapter_no + "."
										+ i));
		}

		chapterPanel.setLayout(new GridLayout(chap_verse_count, 1));
		for (int i = 0; i < chapverse.size(); i++) {
			JPanel panel = new JPanel(new FlowLayout(FlowLayout.LEFT));
			panel.add(new JLabel((i + 1) + ". "));
			String str[] = chapverse.getProperty(
					book_no + "." + chapter_no + "." + (i + 1)).trim().replaceAll("  ", " ").split(
					"[ ]");
			String ref_selected[] = words.getProperty(book_no + "." + chapter_no
					+ "." + (i + 1)).split("[,]");			
			for (int j = 0; j < str.length; j++) {
				if (meanings.get(str[j]) != null) {
					JComboBox combo = new JComboBox( meanings
							.getProperty(str[j]).split(","));
					combo.setSelectedItem(ref_selected[j]);
					panel.add(combo);
				}
			}
			chapterPanel.add(panel);
		}
		chapterPanel.doLayout();
	}

	public static String getBookName(int mbook) {
		return Bible_Books[mbook];
	}

	public static String getLocalFile(String file) {
		ByteArrayOutputStream bos = new ByteArrayOutputStream();
		try {
			FileInputStream is = new FileInputStream(new File(file));
			int c = 0;
			while ((c = is.read()) != -1) {
				bos.write(c);
			}
			bos.close();
		} catch (MalformedURLException e) {
			JOptionPane.showMessageDialog(null, "Error:"
					+ e.getLocalizedMessage());
		} catch (IOException e) {
			JOptionPane.showMessageDialog(null, "Error:"
					+ e.getLocalizedMessage());
		}
		return new String(bos.toByteArray());
	}

	public static void putLocalFile(String file, String content) {
		try {
			FileOutputStream os = new FileOutputStream(new File(file));
			os.write(content.getBytes());
			os.close();
		} catch (IOException e) {
			JOptionPane.showMessageDialog(null, "Error:"
					+ e.getLocalizedMessage());
		}
	}

}
